#ifndef _H_1B94F788C94F6E6C7CAE208F86E96CED_Box_DCPS_H_
#define _H_1B94F788C94F6E6C7CAE208F86E96CED_Box_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Box_.h"


namespace rc_reason_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Box_TypeSupportInterface;

            typedef Box_TypeSupportInterface * Box_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Box_TypeSupportInterface> Box_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Box_TypeSupportInterface> Box_TypeSupportInterface_out;


            class Box_DataWriter;

            typedef Box_DataWriter * Box_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Box_DataWriter> Box_DataWriter_var;
            typedef DDS_DCPSInterface_out < Box_DataWriter> Box_DataWriter_out;


            class Box_DataReader;

            typedef Box_DataReader * Box_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Box_DataReader> Box_DataReader_var;
            typedef DDS_DCPSInterface_out < Box_DataReader> Box_DataReader_out;


            class Box_DataReaderView;

            typedef Box_DataReaderView * Box_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Box_DataReaderView> Box_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Box_DataReaderView> Box_DataReaderView_out;

            struct Box_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Box_, struct Box_Seq_uniq_> Box_Seq;
            typedef DDS_DCPSSequence_var < Box_Seq> Box_Seq_var;
            typedef DDS_DCPSSequence_out < Box_Seq> Box_Seq_out;

            class  Box_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Box_TypeSupportInterface_ptr _ptr_type;
                typedef Box_TypeSupportInterface_var _var_type;

                static Box_TypeSupportInterface_ptr _duplicate (Box_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Box_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Box_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Box_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Box_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Box_TypeSupportInterface () {};
                ~Box_TypeSupportInterface () {};
            private:
                Box_TypeSupportInterface (const Box_TypeSupportInterface &);
                Box_TypeSupportInterface & operator = (const Box_TypeSupportInterface &);
            };

            class  Box_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Box_DataWriter_ptr _ptr_type;
                typedef Box_DataWriter_var _var_type;

                static Box_DataWriter_ptr _duplicate (Box_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Box_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Box_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Box_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Box_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Box_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Box_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Box_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Box_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Box_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Box_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Box_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Box_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Box_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Box_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Box_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Box_& instance_data) = 0;

            protected:
                Box_DataWriter () {};
                ~Box_DataWriter () {};
            private:
                Box_DataWriter (const Box_DataWriter &);
                Box_DataWriter & operator = (const Box_DataWriter &);
            };

            class  Box_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Box_DataReader_ptr _ptr_type;
                typedef Box_DataReader_var _var_type;

                static Box_DataReader_ptr _duplicate (Box_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Box_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Box_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Box_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Box_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Box_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Box_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Box_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Box_& instance) = 0;

            protected:
                Box_DataReader () {};
                ~Box_DataReader () {};
            private:
                Box_DataReader (const Box_DataReader &);
                Box_DataReader & operator = (const Box_DataReader &);
            };

            class  Box_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Box_DataReaderView_ptr _ptr_type;
                typedef Box_DataReaderView_var _var_type;

                static Box_DataReaderView_ptr _duplicate (Box_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Box_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Box_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Box_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Box_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Box_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Box_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Box_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Box_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Box_& instance) = 0;

            protected:
                Box_DataReaderView () {};
                ~Box_DataReaderView () {};
            private:
                Box_DataReaderView (const Box_DataReaderView &);
                Box_DataReaderView & operator = (const Box_DataReaderView &);
            };
        }

    }

}

#endif
