#ifndef _H_AD703C43CAF8DBC01FE3135303A95060_CalibrateBasePlane__H_
#define _H_AD703C43CAF8DBC01FE3135303A95060_CalibrateBasePlane__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "shape_msgs/msg/dds_opensplice/Plane_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  CalibrateBasePlane_Request_
            {
                ::DDS::String_mgr pose_frame_;
                ::geometry_msgs::msg::dds_::Pose_ robot_pose_;
                ::DDS::String_mgr plane_estimation_method_;
                ::DDS::String_mgr stereo_plane_preference_;
                ::DDS::String_mgr region_of_interest_2d_id_;
                ::DDS::Double offset_;
                ::shape_msgs::msg::dds_::Plane_ plane_;
            };

            typedef DDS_DCPSStruct_var<CalibrateBasePlane_Request_> CalibrateBasePlane_Request__var;
            typedef DDS_DCPSStruct_out < CalibrateBasePlane_Request_> CalibrateBasePlane_Request__out;

            struct  CalibrateBasePlane_Response_
            {
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                ::DDS::String_mgr pose_frame_;
                ::shape_msgs::msg::dds_::Plane_ plane_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<CalibrateBasePlane_Response_> CalibrateBasePlane_Response__var;
            typedef DDS_DCPSStruct_out < CalibrateBasePlane_Response_> CalibrateBasePlane_Response__out;

            struct  Sample_CalibrateBasePlane_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::CalibrateBasePlane_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_CalibrateBasePlane_Request_> Sample_CalibrateBasePlane_Request__var;
            typedef DDS_DCPSStruct_out < Sample_CalibrateBasePlane_Request_> Sample_CalibrateBasePlane_Request__out;

            struct  Sample_CalibrateBasePlane_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::CalibrateBasePlane_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_CalibrateBasePlane_Response_> Sample_CalibrateBasePlane_Response__var;
            typedef DDS_DCPSStruct_out < Sample_CalibrateBasePlane_Response_> Sample_CalibrateBasePlane_Response__out;

        }

    }

}

#endif /* _H_AD703C43CAF8DBC01FE3135303A95060_CalibrateBasePlane__H_ */
