#ifndef _H_E78BB80ABEDBD799605B51CCFFD4290B_DetectItems__H_
#define _H_E78BB80ABEDBD799605B51CCFFD4290B_DetectItems__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "rc_reason_msgs/msg/dds_opensplice/Compartment_.h"
#include "rc_reason_msgs/msg/dds_opensplice/ItemModel_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"
#include "rc_reason_msgs/msg/dds_opensplice/Item_.h"
#include "rc_reason_msgs/msg/dds_opensplice/LoadCarrier_.h"
#include "rc_common_msgs/msg/dds_opensplice/ReturnCode_.h"


namespace rc_reason_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  DetectItems_Request_
            {
                struct _item_models__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::ItemModel_, struct _item_models__seq_uniq_ > _item_models__seq;
                typedef DDS_DCPSSequence_var< _item_models__seq > _item_models__seq_var;
                typedef DDS_DCPSSequence_out< _item_models__seq > _item_models__seq_out;
                ::DDS::String_mgr pose_frame_;
                ::DDS::String_mgr region_of_interest_id_;
                ::DDS::String_mgr load_carrier_id_;
                ::rc_reason_msgs::msg::dds_::Compartment_ load_carrier_compartment_;
                _item_models__seq item_models_;
                ::geometry_msgs::msg::dds_::Pose_ robot_pose_;
            };

            typedef DDS_DCPSStruct_var<DetectItems_Request_> DetectItems_Request__var;
            typedef DDS_DCPSStruct_out < DetectItems_Request_> DetectItems_Request__out;

            struct  DetectItems_Response_
            {
                struct _items__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::Item_, struct _items__seq_uniq_ > _items__seq;
                typedef DDS_DCPSSequence_var< _items__seq > _items__seq_var;
                typedef DDS_DCPSSequence_out< _items__seq > _items__seq_out;
                struct _load_carriers__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::rc_reason_msgs::msg::dds_::LoadCarrier_, struct _load_carriers__seq_uniq_ > _load_carriers__seq;
                typedef DDS_DCPSSequence_var< _load_carriers__seq > _load_carriers__seq_var;
                typedef DDS_DCPSSequence_out< _load_carriers__seq > _load_carriers__seq_out;
                ::builtin_interfaces::msg::dds_::Time_ timestamp_;
                _items__seq items_;
                _load_carriers__seq load_carriers_;
                ::rc_common_msgs::msg::dds_::ReturnCode_ return_code_;
            };

            typedef DDS_DCPSStruct_var<DetectItems_Response_> DetectItems_Response__var;
            typedef DDS_DCPSStruct_out < DetectItems_Response_> DetectItems_Response__out;

            struct  Sample_DetectItems_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DetectItems_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_DetectItems_Request_> Sample_DetectItems_Request__var;
            typedef DDS_DCPSStruct_out < Sample_DetectItems_Request_> Sample_DetectItems_Request__out;

            struct  Sample_DetectItems_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::rc_reason_msgs::srv::dds_::DetectItems_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_DetectItems_Response_> Sample_DetectItems_Response__var;
            typedef DDS_DCPSStruct_out < Sample_DetectItems_Response_> Sample_DetectItems_Response__out;

        }

    }

}

#endif /* _H_E78BB80ABEDBD799605B51CCFFD4290B_DetectItems__H_ */
